/*
 copyright(c) 2007 arton

 Usage of the works is permitted provided that this instrument is retained with the works, 
 so that any entity that uses the works is notified of this instrument. 

 DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY. 

 [2004, Fair License: rhid.com/fair] 
*/

#include "stdafx.h"

#include "win32ole.net.h"

namespace Win32olenet {
    bool OleEnumerator::MoveNext()
    {
        VARIANT v;
        unsigned long fetched(0);
        VariantInit(&v);
        if (pEnumVariant->Next(1, &v, &fetched) == S_OK)
        {
            current = WIN32OLE::getObject(v);
            return true;
        }
        return false;
    }
    void OleEnumerator::Reset()
    {
        pEnumVariant->Reset();
    }
    OleEnumerator::~OleEnumerator()
    {
        if (pEnumVariant)
            pEnumVariant->Release();
        pEnumVariant = NULL;
    }
}